---
title: Create Store (GoogleApps)
description: The POST {{apiPath}}/v1/environments/{{envID}}/propagation/stores operation adds a new identity store resource to the specified environment resource.
component: pingone-api
page_id: pingone-api:platform:identity-propagation-provisioning/propagation-stores/create-store-googleapps
canonical_url: https://developer.pingidentity.com/pingone-api/platform/identity-propagation-provisioning/propagation-stores/create-store-googleapps.html
section_ids:
  prerequisites: Prerequisites
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Create Store (GoogleApps)

##

```none
POST {{apiPath}}/v1/environments/{{envID}}/propagation/stores
```

The `POST {{apiPath}}/v1/environments/{{envID}}/propagation/stores` operation adds a new identity store resource to the specified environment resource.

### Prerequisites

* Refer to [Identity Propagation (Provisioning)](../../identity-propagation-provisioning.html) for important overview information.

> **Collapse: Request Model**
>
> Refer to [Propagation store base data model](../propagation-stores.html#propagation-store-base-data-model) and [Propagation store GoogleApps configuration data model](../propagation-stores.html#propagation-store-googleapps-configuration-data-model) for full property descriptions.
>
> | Property                                          | Type    | Required? |
> | ------------------------------------------------- | ------- | --------- |
> | `configuration.APPLICATION_NAME`                  | String  | Required  |
> | `configuration.CREATE_USERS`                      | Boolean | Optional  |
> | `configuration.DEPROVISION_USERS`                 | Boolean | Optional  |
> | `configuration.DISABLE_USERS`                     | Boolean | Optional  |
> | `configuration.DOMAIN`                            | String  | Required  |
> | `configuration.OAUTH_ACCESS_TOKEN`                | String  | Required  |
> | `configuration.OAUTH_CLIENT_ID`                   | String  | Required  |
> | `configuration.OAUTH_CLIENT_SECRET`               | String  | Required  |
> | `configuration.OAUTH_REFRESH_TOKEN`               | String  | Required  |
> | `configuration.PROVISION_DISABLED_USERS_PROV_OPT` | Boolean | Optional  |
> | `configuration.REMOVE_ACTION`                     | String  | Optional  |
> | `configuration.UPDATE_USERS`                      | Boolean | Optional  |
> | `description`                                     | String  | Optional  |
> | `image.href`                                      | String  | Optional  |
> | `managed`                                         | Boolean | Optional  |
> | `name`                                            | String  | Required  |
> | `status`                                          | String  | Optional  |
> | `type`                                            | String  | Required  |

This operation sends and returns the connection properties for an identity store with `"type":"GoogleApps"`. For information on the available and required keys in the `configuration` object of the request body, review `connectionProfiles[].connectionAttributes[]` and `attributeMetadata.capabilities[]` in the response to [POST Identity Propagation Store Metadata (GoogleApps)](../propagation-store-metadata/identity-propagation-store-metadata-googleapps.html).

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "type": "GoogleApps",
    "status": "INACTIVE",
    "configuration": {
        "APPLICATION_NAME": "Provisioning",
        "CREATE_USERS": true,
        "DEPROVISION_USERS": true,
        "DISABLE_USERS": true,
        "DOMAIN": "domain",
        "OAUTH_ACCESS_TOKEN": "amlYM1UwRmpscEljTjlKMGExdWdVMTc3dzVtb1hJYU9jR2hhamg3cHREdENPSUNiZUZsTzF2cGlsS0JW",
        "OAUTH_CLIENT_ID": "oauth_client_id",
        "OAUTH_CLIENT_SECRET": "oauth_client_secret",
        "OAUTH_REFRESH_TOKEN": "SFZNcjUxbmVGZXRSWHhoUUJLN2RnMmxqTFhtTTJSTHdkcUM2Rmo0bU9pVWwxZnRjdnN3RHE1dW9KSDVS",
        "PROVISION_DISABLED_USERS_PROV_OPT": true,
        "REMOVE_ACTION": "Disable",
        "UPDATE_USERS": true
    },
    "name": "google connection",
    "managed": true
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/propagation/stores' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "type": "GoogleApps",
    "status": "INACTIVE",
    "configuration": {
        "APPLICATION_NAME": "Provisioning",
        "CREATE_USERS": true,
        "DEPROVISION_USERS": true,
        "DISABLE_USERS": true,
        "DOMAIN": "domain",
        "OAUTH_ACCESS_TOKEN": "amlYM1UwRmpscEljTjlKMGExdWdVMTc3dzVtb1hJYU9jR2hhamg3cHREdENPSUNiZUZsTzF2cGlsS0JW",
        "OAUTH_CLIENT_ID": "oauth_client_id",
        "OAUTH_CLIENT_SECRET": "oauth_client_secret",
        "OAUTH_REFRESH_TOKEN": "SFZNcjUxbmVGZXRSWHhoUUJLN2RnMmxqTFhtTTJSTHdkcUM2Rmo0bU9pVWwxZnRjdnN3RHE1dW9KSDVS",
        "PROVISION_DISABLED_USERS_PROV_OPT": true,
        "REMOVE_ACTION": "Disable",
        "UPDATE_USERS": true
    },
    "name": "google connection",
    "managed": true
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/propagation/stores")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""type"": ""GoogleApps""," + "\n" +
@"    ""status"": ""INACTIVE""," + "\n" +
@"    ""configuration"": {" + "\n" +
@"        ""APPLICATION_NAME"": ""Provisioning""," + "\n" +
@"        ""CREATE_USERS"": true," + "\n" +
@"        ""DEPROVISION_USERS"": true," + "\n" +
@"        ""DISABLE_USERS"": true," + "\n" +
@"        ""DOMAIN"": ""domain""," + "\n" +
@"        ""OAUTH_ACCESS_TOKEN"": ""amlYM1UwRmpscEljTjlKMGExdWdVMTc3dzVtb1hJYU9jR2hhamg3cHREdENPSUNiZUZsTzF2cGlsS0JW""," + "\n" +
@"        ""OAUTH_CLIENT_ID"": ""oauth_client_id""," + "\n" +
@"        ""OAUTH_CLIENT_SECRET"": ""oauth_client_secret""," + "\n" +
@"        ""OAUTH_REFRESH_TOKEN"": ""SFZNcjUxbmVGZXRSWHhoUUJLN2RnMmxqTFhtTTJSTHdkcUM2Rmo0bU9pVWwxZnRjdnN3RHE1dW9KSDVS""," + "\n" +
@"        ""PROVISION_DISABLED_USERS_PROV_OPT"": true," + "\n" +
@"        ""REMOVE_ACTION"": ""Disable""," + "\n" +
@"        ""UPDATE_USERS"": true" + "\n" +
@"    }," + "\n" +
@"    ""name"": ""google connection""," + "\n" +
@"    ""managed"": true" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/propagation/stores"
  method := "POST"

  payload := strings.NewReader(`{
    "type": "GoogleApps",
    "status": "INACTIVE",
    "configuration": {
        "APPLICATION_NAME": "Provisioning",
        "CREATE_USERS": true,
        "DEPROVISION_USERS": true,
        "DISABLE_USERS": true,
        "DOMAIN": "domain",
        "OAUTH_ACCESS_TOKEN": "amlYM1UwRmpscEljTjlKMGExdWdVMTc3dzVtb1hJYU9jR2hhamg3cHREdENPSUNiZUZsTzF2cGlsS0JW",
        "OAUTH_CLIENT_ID": "oauth_client_id",
        "OAUTH_CLIENT_SECRET": "oauth_client_secret",
        "OAUTH_REFRESH_TOKEN": "SFZNcjUxbmVGZXRSWHhoUUJLN2RnMmxqTFhtTTJSTHdkcUM2Rmo0bU9pVWwxZnRjdnN3RHE1dW9KSDVS",
        "PROVISION_DISABLED_USERS_PROV_OPT": true,
        "REMOVE_ACTION": "Disable",
        "UPDATE_USERS": true
    },
    "name": "google connection",
    "managed": true
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
POST /v1/environments/{{envID}}/propagation/stores HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "type": "GoogleApps",
    "status": "INACTIVE",
    "configuration": {
        "APPLICATION_NAME": "Provisioning",
        "CREATE_USERS": true,
        "DEPROVISION_USERS": true,
        "DISABLE_USERS": true,
        "DOMAIN": "domain",
        "OAUTH_ACCESS_TOKEN": "amlYM1UwRmpscEljTjlKMGExdWdVMTc3dzVtb1hJYU9jR2hhamg3cHREdENPSUNiZUZsTzF2cGlsS0JW",
        "OAUTH_CLIENT_ID": "oauth_client_id",
        "OAUTH_CLIENT_SECRET": "oauth_client_secret",
        "OAUTH_REFRESH_TOKEN": "SFZNcjUxbmVGZXRSWHhoUUJLN2RnMmxqTFhtTTJSTHdkcUM2Rmo0bU9pVWwxZnRjdnN3RHE1dW9KSDVS",
        "PROVISION_DISABLED_USERS_PROV_OPT": true,
        "REMOVE_ACTION": "Disable",
        "UPDATE_USERS": true
    },
    "name": "google connection",
    "managed": true
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"type\": \"GoogleApps\",\n    \"status\": \"INACTIVE\",\n    \"configuration\": {\n        \"APPLICATION_NAME\": \"Provisioning\",\n        \"CREATE_USERS\": true,\n        \"DEPROVISION_USERS\": true,\n        \"DISABLE_USERS\": true,\n        \"DOMAIN\": \"domain\",\n        \"OAUTH_ACCESS_TOKEN\": \"amlYM1UwRmpscEljTjlKMGExdWdVMTc3dzVtb1hJYU9jR2hhamg3cHREdENPSUNiZUZsTzF2cGlsS0JW\",\n        \"OAUTH_CLIENT_ID\": \"oauth_client_id\",\n        \"OAUTH_CLIENT_SECRET\": \"oauth_client_secret\",\n        \"OAUTH_REFRESH_TOKEN\": \"SFZNcjUxbmVGZXRSWHhoUUJLN2RnMmxqTFhtTTJSTHdkcUM2Rmo0bU9pVWwxZnRjdnN3RHE1dW9KSDVS\",\n        \"PROVISION_DISABLED_USERS_PROV_OPT\": true,\n        \"REMOVE_ACTION\": \"Disable\",\n        \"UPDATE_USERS\": true\n    },\n    \"name\": \"google connection\",\n    \"managed\": true\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/propagation/stores")
  .method("POST", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/propagation/stores",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "type": "GoogleApps",
    "status": "INACTIVE",
    "configuration": {
      "APPLICATION_NAME": "Provisioning",
      "CREATE_USERS": true,
      "DEPROVISION_USERS": true,
      "DISABLE_USERS": true,
      "DOMAIN": "domain",
      "OAUTH_ACCESS_TOKEN": "amlYM1UwRmpscEljTjlKMGExdWdVMTc3dzVtb1hJYU9jR2hhamg3cHREdENPSUNiZUZsTzF2cGlsS0JW",
      "OAUTH_CLIENT_ID": "oauth_client_id",
      "OAUTH_CLIENT_SECRET": "oauth_client_secret",
      "OAUTH_REFRESH_TOKEN": "SFZNcjUxbmVGZXRSWHhoUUJLN2RnMmxqTFhtTTJSTHdkcUM2Rmo0bU9pVWwxZnRjdnN3RHE1dW9KSDVS",
      "PROVISION_DISABLED_USERS_PROV_OPT": true,
      "REMOVE_ACTION": "Disable",
      "UPDATE_USERS": true
    },
    "name": "google connection",
    "managed": true
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/v1/environments/{{envID}}/propagation/stores',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "type": "GoogleApps",
    "status": "INACTIVE",
    "configuration": {
      "APPLICATION_NAME": "Provisioning",
      "CREATE_USERS": true,
      "DEPROVISION_USERS": true,
      "DISABLE_USERS": true,
      "DOMAIN": "domain",
      "OAUTH_ACCESS_TOKEN": "amlYM1UwRmpscEljTjlKMGExdWdVMTc3dzVtb1hJYU9jR2hhamg3cHREdENPSUNiZUZsTzF2cGlsS0JW",
      "OAUTH_CLIENT_ID": "oauth_client_id",
      "OAUTH_CLIENT_SECRET": "oauth_client_secret",
      "OAUTH_REFRESH_TOKEN": "SFZNcjUxbmVGZXRSWHhoUUJLN2RnMmxqTFhtTTJSTHdkcUM2Rmo0bU9pVWwxZnRjdnN3RHE1dW9KSDVS",
      "PROVISION_DISABLED_USERS_PROV_OPT": true,
      "REMOVE_ACTION": "Disable",
      "UPDATE_USERS": true
    },
    "name": "google connection",
    "managed": true
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/propagation/stores"

payload = json.dumps({
  "type": "GoogleApps",
  "status": "INACTIVE",
  "configuration": {
    "APPLICATION_NAME": "Provisioning",
    "CREATE_USERS": True,
    "DEPROVISION_USERS": True,
    "DISABLE_USERS": True,
    "DOMAIN": "domain",
    "OAUTH_ACCESS_TOKEN": "amlYM1UwRmpscEljTjlKMGExdWdVMTc3dzVtb1hJYU9jR2hhamg3cHREdENPSUNiZUZsTzF2cGlsS0JW",
    "OAUTH_CLIENT_ID": "oauth_client_id",
    "OAUTH_CLIENT_SECRET": "oauth_client_secret",
    "OAUTH_REFRESH_TOKEN": "SFZNcjUxbmVGZXRSWHhoUUJLN2RnMmxqTFhtTTJSTHdkcUM2Rmo0bU9pVWwxZnRjdnN3RHE1dW9KSDVS",
    "PROVISION_DISABLED_USERS_PROV_OPT": True,
    "REMOVE_ACTION": "Disable",
    "UPDATE_USERS": True
  },
  "name": "google connection",
  "managed": True
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/propagation/stores');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "type": "GoogleApps",\n    "status": "INACTIVE",\n    "configuration": {\n        "APPLICATION_NAME": "Provisioning",\n        "CREATE_USERS": true,\n        "DEPROVISION_USERS": true,\n        "DISABLE_USERS": true,\n        "DOMAIN": "domain",\n        "OAUTH_ACCESS_TOKEN": "amlYM1UwRmpscEljTjlKMGExdWdVMTc3dzVtb1hJYU9jR2hhamg3cHREdENPSUNiZUZsTzF2cGlsS0JW",\n        "OAUTH_CLIENT_ID": "oauth_client_id",\n        "OAUTH_CLIENT_SECRET": "oauth_client_secret",\n        "OAUTH_REFRESH_TOKEN": "SFZNcjUxbmVGZXRSWHhoUUJLN2RnMmxqTFhtTTJSTHdkcUM2Rmo0bU9pVWwxZnRjdnN3RHE1dW9KSDVS",\n        "PROVISION_DISABLED_USERS_PROV_OPT": true,\n        "REMOVE_ACTION": "Disable",\n        "UPDATE_USERS": true\n    },\n    "name": "google connection",\n    "managed": true\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/propagation/stores")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "type": "GoogleApps",
  "status": "INACTIVE",
  "configuration": {
    "APPLICATION_NAME": "Provisioning",
    "CREATE_USERS": true,
    "DEPROVISION_USERS": true,
    "DISABLE_USERS": true,
    "DOMAIN": "domain",
    "OAUTH_ACCESS_TOKEN": "amlYM1UwRmpscEljTjlKMGExdWdVMTc3dzVtb1hJYU9jR2hhamg3cHREdENPSUNiZUZsTzF2cGlsS0JW",
    "OAUTH_CLIENT_ID": "oauth_client_id",
    "OAUTH_CLIENT_SECRET": "oauth_client_secret",
    "OAUTH_REFRESH_TOKEN": "SFZNcjUxbmVGZXRSWHhoUUJLN2RnMmxqTFhtTTJSTHdkcUM2Rmo0bU9pVWwxZnRjdnN3RHE1dW9KSDVS",
    "PROVISION_DISABLED_USERS_PROV_OPT": true,
    "REMOVE_ACTION": "Disable",
    "UPDATE_USERS": true
  },
  "name": "google connection",
  "managed": true
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"type\": \"GoogleApps\",\n    \"status\": \"INACTIVE\",\n    \"configuration\": {\n        \"APPLICATION_NAME\": \"Provisioning\",\n        \"CREATE_USERS\": true,\n        \"DEPROVISION_USERS\": true,\n        \"DISABLE_USERS\": true,\n        \"DOMAIN\": \"domain\",\n        \"OAUTH_ACCESS_TOKEN\": \"amlYM1UwRmpscEljTjlKMGExdWdVMTc3dzVtb1hJYU9jR2hhamg3cHREdENPSUNiZUZsTzF2cGlsS0JW\",\n        \"OAUTH_CLIENT_ID\": \"oauth_client_id\",\n        \"OAUTH_CLIENT_SECRET\": \"oauth_client_secret\",\n        \"OAUTH_REFRESH_TOKEN\": \"SFZNcjUxbmVGZXRSWHhoUUJLN2RnMmxqTFhtTTJSTHdkcUM2Rmo0bU9pVWwxZnRjdnN3RHE1dW9KSDVS\",\n        \"PROVISION_DISABLED_USERS_PROV_OPT\": true,\n        \"REMOVE_ACTION\": \"Disable\",\n        \"UPDATE_USERS\": true\n    },\n    \"name\": \"google connection\",\n    \"managed\": true\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/propagation/stores")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

201 Created

```json
{
    "id": "bba6936d-ad7b-4c13-beac-f792b6e0bda4",
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "createdAt": "2023-01-04T15:04:10.127Z",
    "updatedAt": "2023-01-04T15:04:10.127Z",
    "image": {},
    "type": "GoogleApps",
    "status": "INACTIVE",
    "configuration": {
        "APPLICATION_NAME": "Provisioning",
        "CREATE_USERS": true,
        "DEPROVISION_USERS": true,
        "DISABLE_USERS": true,
        "DOMAIN": "domain",
        "OAUTH_ACCESS_TOKEN": "amlYM1UwRmpscEljTjlKMGExdWdVMTc3dzVtb1hJYU9jR2hhamg3cHREdENPSUNiZUZsTzF2cGlsS0JW",
        "OAUTH_CLIENT_ID": "oauth_client_id",
        "OAUTH_CLIENT_SECRET": "oauth_client_secret",
        "OAUTH_REFRESH_TOKEN": "SFZNcjUxbmVGZXRSWHhoUUJLN2RnMmxqTFhtTTJSTHdkcUM2Rmo0bU9pVWwxZnRjdnN3RHE1dW9KSDVS",
        "PROVISION_DISABLED_USERS_PROV_OPT": true,
        "REMOVE_ACTION": "Disable",
        "UPDATE_USERS": true
    },
    "name": "google connection",
    "managed": true,
    "_links": {
        "self": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/propagation/stores/bba6936d-ad7b-4c13-beac-f792b6e0bda4"
        },
        "update": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/propagation/stores/bba6936d-ad7b-4c13-beac-f792b6e0bda4"
        },
        "delete": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/propagation/stores/bba6936d-ad7b-4c13-beac-f792b6e0bda4"
        }
    }
}
```
